ArcTo (JavaFX 27)
Description: declaration: module: javafx.graphics, package: javafx.scene.shape, class: ArcTo

# Class ArcTo

java.lang.Object
javafx.scene.shape.PathElement
javafx.scene.shape.ArcTo

public class ArcTo extends PathElement
A path element that forms an arc from the previous coordinates to the specified x and y coordinates using the specified radius.

For more information on path elements see the `Path` and `PathElement` classes.

Example:

    import javafx.scene.shape.*;

    Path path = new Path();

    MoveTo moveTo = new MoveTo();
    moveTo.setX(0.0);
    moveTo.setY(0.0);

    ArcTo arcTo = new ArcTo();
    arcTo.setX(50.0);
    arcTo.setY(50.0);
    arcTo.setRadiusX(50.0);
    arcTo.setRadiusY(50.0);

    path.getElements().add(moveTo);
    path.getElements().add(arcTo);

Following image demonstrates `radiusX`, `radiusY` and `xAxisRotation` parameters: `radiusX` is the horizontal radius of the full ellipse of which this arc is a partial section, `radiusY` is its vertical radius. `xAxisRotation` defines the rotation of the ellipse in degrees.

In most cases, there are four options of how to draw an arc from starting point to given end coordinates. They can be distinguished by `largeArcFlag` and `sweepFlag` parameters. `largeArcFlag == true` means that the arc greater than 180 degrees will be drawn. `sweepFlag == true` means that the arc will be drawn in the positive angle direction - i.e. the angle in the ellipse formula will increase from `[fromX, fromY]` to `[x,y]`. Following images demonstrate this behavior:

Since:
  JavaFX 2.0

- ## Property Summary

  Properties
  Type
  Property
  Description
  `final BooleanProperty`
  `largeArcFlag`
  The large arc flag.
  `final DoubleProperty`
  `radiusX`
  The horizontal radius to use for the arc.
  `final DoubleProperty`
  `radiusY`
  The vertical radius to use for the arc.
  `final BooleanProperty`
  `sweepFlag`
  The sweep flag
  `final DoubleProperty`
  `XAxisRotation`
  The x-axis rotation in degrees.
  `final DoubleProperty`
  `x`
  The x coordinate to arc to.
  `final DoubleProperty`
  `y`
  The y coordinate to arc to.

  ### Properties declared in class PathElement

  `absolute`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `ArcTo()`
  Creates an empty instance of ArcTo.
  `ArcTo(double radiusX, double radiusY, double xAxisRotation, double x, double y, boolean largeArcFlag, boolean sweepFlag)`
  Creates a new instance of ArcTo.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `final double`
  `getRadiusX()`
  Gets the value of the `radiusX` property.
  `final double`
  `getRadiusY()`
  Gets the value of the `radiusY` property.
  `final double`
  `getX()`
  Gets the value of the `x` property.
  `final double`
  `getXAxisRotation()`
  Gets the x-axis rotation in degrees.
  `final double`
  `getY()`
  Gets the value of the `y` property.
  `final boolean`
  `isLargeArcFlag()`
  Gets the value of the `largeArcFlag` property.
  `final boolean`
  `isSweepFlag()`
  Gets the value of the `sweepFlag` property.
  `final BooleanProperty`
  `largeArcFlagProperty()`
  The large arc flag.
  `final DoubleProperty`
  `radiusXProperty()`
  The horizontal radius to use for the arc.
  `final DoubleProperty`
  `radiusYProperty()`
  The vertical radius to use for the arc.
  `final void`
  `setLargeArcFlag(boolean value)`
  Sets the value of the `largeArcFlag` property.
  `final void`
  `setRadiusX(double value)`
  Sets the value of the `radiusX` property.
  `final void`
  `setRadiusY(double value)`
  Sets the value of the `radiusY` property.
  `final void`
  `setSweepFlag(boolean value)`
  Sets the value of the `sweepFlag` property.
  `final void`
  `setX(double value)`
  Sets the value of the `x` property.
  `final void`
  `setXAxisRotation(double value)`
  Sets the x-axis rotation in degrees.
  `final void`
  `setY(double value)`
  Sets the value of the `y` property.
  `final BooleanProperty`
  `sweepFlagProperty()`
  The sweep flag
  `String`
  `toString()`
  Returns a string representation of this `ArcTo` object.
  `final DoubleProperty`
  `XAxisRotationProperty()`
  The x-axis rotation in degrees.
  `final DoubleProperty`
  `xProperty()`
  The x coordinate to arc to.
  `final DoubleProperty`
  `yProperty()`
  The y coordinate to arc to.

  ### Methods declared in class PathElement

  `absoluteProperty, isAbsolute, setAbsolute`

  ### Methods declared in class Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Property Details

  - ### radiusX

    public final DoubleProperty radiusXProperty
    The horizontal radius to use for the arc.
    Default value:
      0.0
    See Also:
      - `getRadiusX()`
      - `setRadiusX(double)`
      - `radiusXProperty()`

  - ### radiusY

    public final DoubleProperty radiusYProperty
    The vertical radius to use for the arc.
    Default value:
      0.0
    See Also:
      - `getRadiusY()`
      - `setRadiusY(double)`
      - `radiusYProperty()`

  - ### XAxisRotation

    public final DoubleProperty XAxisRotationProperty
    The x-axis rotation in degrees.
    See Also:
      - `getXAxisRotation()`
      - `setXAxisRotation(double)`
      - `XAxisRotationProperty()`

  - ### largeArcFlag

    public final BooleanProperty largeArcFlagProperty
    The large arc flag.
    Default value:
      false
    See Also:
      - `isLargeArcFlag()`
      - `setLargeArcFlag(boolean)`
      - `largeArcFlagProperty()`

  - ### sweepFlag

    public final BooleanProperty sweepFlagProperty
    The sweep flag
    Default value:
      false
    See Also:
      - `isSweepFlag()`
      - `setSweepFlag(boolean)`
      - `sweepFlagProperty()`

  - ### x

    public final DoubleProperty xProperty
    The x coordinate to arc to.
    Default value:
      0.0
    See Also:
      - `getX()`
      - `setX(double)`
      - `xProperty()`

  - ### y

    public final DoubleProperty yProperty
    The y coordinate to arc to.
    Default value:
      0.0
    See Also:
      - `getY()`
      - `setY(double)`
      - `yProperty()`

- ## Constructor Details

  - ### ArcTo

    public ArcTo()
    Creates an empty instance of ArcTo.

  - ### ArcTo

    public ArcTo(double radiusX, double radiusY, double xAxisRotation, double x, double y, boolean largeArcFlag, boolean sweepFlag)
    Creates a new instance of ArcTo.
    Parameters:
      `radiusX` - horizontal radius of the arc
      `radiusY` - vertical radius of the arc
      `xAxisRotation` - the x-axis rotation in degrees
      `x` - horizontal position of the arc end point
      `y` - vertical position of the arc end point
      `largeArcFlag` - large arg flag: determines which arc to use (large/small)
      `sweepFlag` - sweep flag: determines which arc to use (direction)

- ## Method Details

  - ### setRadiusX

    public final void setRadiusX(double value)
    Sets the value of the `radiusX` property.
    Property description:
      The horizontal radius to use for the arc.
    Default value:
      0.0
    Parameters:
      `value` - the value for the `radiusX` property
    See Also:
      - `getRadiusX()`
      - `radiusXProperty()`

  - ### getRadiusX

    public final double getRadiusX()
    Gets the value of the `radiusX` property.
    Property description:
      The horizontal radius to use for the arc.
    Default value:
      0.0
    Returns:
      the value of the `radiusX` property
    See Also:
      - `setRadiusX(double)`
      - `radiusXProperty()`

  - ### radiusXProperty

    public final DoubleProperty radiusXProperty()
    The horizontal radius to use for the arc.
    Default value:
      0.0
    Returns:
      the `radiusX` property
    See Also:
      - `getRadiusX()`
      - `setRadiusX(double)`

  - ### setRadiusY

    public final void setRadiusY(double value)
    Sets the value of the `radiusY` property.
    Property description:
      The vertical radius to use for the arc.
    Default value:
      0.0
    Parameters:
      `value` - the value for the `radiusY` property
    See Also:
      - `getRadiusY()`
      - `radiusYProperty()`

  - ### getRadiusY

    public final double getRadiusY()
    Gets the value of the `radiusY` property.
    Property description:
      The vertical radius to use for the arc.
    Default value:
      0.0
    Returns:
      the value of the `radiusY` property
    See Also:
      - `setRadiusY(double)`
      - `radiusYProperty()`

  - ### radiusYProperty

    public final DoubleProperty radiusYProperty()
    The vertical radius to use for the arc.
    Default value:
      0.0
    Returns:
      the `radiusY` property
    See Also:
      - `getRadiusY()`
      - `setRadiusY(double)`

  - ### setXAxisRotation

    public final void setXAxisRotation(double value)
    Sets the x-axis rotation in degrees.
    Parameters:
      `value` - the x-axis rotation in degrees.

  - ### getXAxisRotation

    public final double getXAxisRotation()
    Gets the x-axis rotation in degrees.
    Returns:
      the x-axis rotation in degrees.

  - ### XAxisRotationProperty

    public final DoubleProperty XAxisRotationProperty()
    The x-axis rotation in degrees.
    Returns:
      The XAxisRotation property
    See Also:
      - `getXAxisRotation()`
      - `setXAxisRotation(double)`

  - ### setLargeArcFlag

    public final void setLargeArcFlag(boolean value)
    Sets the value of the `largeArcFlag` property.
    Property description:
      The large arc flag.
    Default value:
      false
    Parameters:
      `value` - the value for the `largeArcFlag` property
    See Also:
      - `isLargeArcFlag()`
      - `largeArcFlagProperty()`

  - ### isLargeArcFlag

    public final boolean isLargeArcFlag()
    Gets the value of the `largeArcFlag` property.
    Property description:
      The large arc flag.
    Default value:
      false
    Returns:
      the value of the `largeArcFlag` property
    See Also:
      - `setLargeArcFlag(boolean)`
      - `largeArcFlagProperty()`

  - ### largeArcFlagProperty

    public final BooleanProperty largeArcFlagProperty()
    The large arc flag.
    Default value:
      false
    Returns:
      the `largeArcFlag` property
    See Also:
      - `isLargeArcFlag()`
      - `setLargeArcFlag(boolean)`

  - ### setSweepFlag

    public final void setSweepFlag(boolean value)
    Sets the value of the `sweepFlag` property.
    Property description:
      The sweep flag
    Default value:
      false
    Parameters:
      `value` - the value for the `sweepFlag` property
    See Also:
      - `isSweepFlag()`
      - `sweepFlagProperty()`

  - ### isSweepFlag

    public final boolean isSweepFlag()
    Gets the value of the `sweepFlag` property.
    Property description:
      The sweep flag
    Default value:
      false
    Returns:
      the value of the `sweepFlag` property
    See Also:
      - `setSweepFlag(boolean)`
      - `sweepFlagProperty()`

  - ### sweepFlagProperty

    public final BooleanProperty sweepFlagProperty()
    The sweep flag
    Default value:
      false
    Returns:
      the `sweepFlag` property
    See Also:
      - `isSweepFlag()`
      - `setSweepFlag(boolean)`

  - ### setX

    public final void setX(double value)
    Sets the value of the `x` property.
    Property description:
      The x coordinate to arc to.
    Default value:
      0.0
    Parameters:
      `value` - the value for the `x` property
    See Also:
      - `getX()`
      - `xProperty()`

  - ### getX

    public final double getX()
    Gets the value of the `x` property.
    Property description:
      The x coordinate to arc to.
    Default value:
      0.0
    Returns:
      the value of the `x` property
    See Also:
      - `setX(double)`
      - `xProperty()`

  - ### xProperty

    public final DoubleProperty xProperty()
    The x coordinate to arc to.
    Default value:
      0.0
    Returns:
      the `x` property
    See Also:
      - `getX()`
      - `setX(double)`

  - ### setY

    public final void setY(double value)
    Sets the value of the `y` property.
    Property description:
      The y coordinate to arc to.
    Default value:
      0.0
    Parameters:
      `value` - the value for the `y` property
    See Also:
      - `getY()`
      - `yProperty()`

  - ### getY

    public final double getY()
    Gets the value of the `y` property.
    Property description:
      The y coordinate to arc to.
    Default value:
      0.0
    Returns:
      the value of the `y` property
    See Also:
      - `setY(double)`
      - `yProperty()`

  - ### yProperty

    public final DoubleProperty yProperty()
    The y coordinate to arc to.
    Default value:
      0.0
    Returns:
      the `y` property
    See Also:
      - `getY()`
      - `setY(double)`

  - ### toString

    public String toString()
    Returns a string representation of this `ArcTo` object.
    Overrides:
      `toString` in class `Object`
    Returns:
      a string representation of this `ArcTo` object.